import {
  storage,
  needLoginList,
  backCodeList
} from "@/utils/tools.js"
// 此vm参数为页面的实例，可以通过它引用vuex中的变量
module.exports = (vm) => {
  // 初始化请求配置
  uni.$u.http.setConfig((config) => {
    // /* config 为默认全局配置*/
    // config.baseURL = 'http://192.168.0.70:8299/api'; /* 根域名 */
	// config.baseURL = 'http://192.168.0.17:8299/api'; /* 根域名 */
    // config.baseURL = 'http://192.168.0.151:8299/api'; /* 根域名 */
    // config.baseURL = 'https://bwshop.caiquanwang.com.cn/prod-api/api'
	config.baseURL = 'http://192.168.0.70:8181/api'; //郭
	// config.baseURL = 'https://peihu.songlanyun.com/prod-api/api'
    // config.baseURL = 'https://wrj.songlanyun.com/prod-api/api'; /* 根域名 */
    return config
  })

  // 请求拦截
  uni.$u.http.interceptors.request.use((config) => { // 可使用async await 做异步操作
    // 初始化请求拦截器时，会执行此方法，此时data为undefined，赋予默认{}
    config.data = config.data || {}
    config.header.apiToken = storage.get('apiToken') //生成环境
    return config
  }, config => { // 可使用async await 做异步操作
    return Promise.reject(config)
  })

  // 响应拦截
  uni.$u.http.interceptors.response.use((response) => {
    /* 对响应成功做点什么 可使用async await 做异步操作*/
    const data = response.data
    // 自定义参数
    const custom = response.config?.custom
    if (data.code !== 200) {
      if (needLoginList.includes(data.code)) { // 未注册用户
        // 判断登录接口不需要跳转
        if (response.config.url == '/miniapp/user/user/authorization/login') {
          return data
        } else {
          uni.$u.toast('请登录！');
          setTimeout(() => {
            uni.navigateTo({
              url: '/pages/login/index',
            });
          }, 1000)
          return Promise.reject(data)
        }
      }
      // 如果没有显式定义custom的toast参数为false的话，默认对报错进行toast弹出提示
      if (custom.toast !== false) {
        uni.$u.toast(data.msg);
        if (backCodeList.includes(data.code)) {  //返回码为backCodeList中的值，则返回上一页
          setTimeout(() => {
            uni.navigateBack();
          }, 1000)
        }
        return Promise.reject(data)
      }
      if (data.code == 401) {
        setTimeout(() => {
          uni.navigateTo({
            url: '/pages/login/index',
          });
        }, 500)
      }
      // 如果需要catch返回，则进行reject
      if (custom?.catch) {
        return Promise.reject(data)
      } else {
        // 否则返回一个pending中的promise，请求不会进入catch中
        return new Promise(() => { })
      }
    }
    // return data.data === undefined ? {} : data
    return data
  }, (response) => {
    // 对响应错误做点什么 （statusCode !== 200）
    return Promise.reject(response)
  })
}